!= Module BasicEnvInit
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: basicenvmpi.f90,v 1.3 2009-08-24 03:50:12 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
subroutine BasicEnvInit_upper(Humidity, TempStrat, Dhight, z_TempBasicZ, z_PressBasicZ)
  !
  !
  !ǥեȤδܾꤹ뤿Υ֥롼. 
  !ܾ׻, BasicSet ⥸塼ͤ. 
  !
  !ѥν꤫, ܾ(hogeBasicZ ѿ)
  !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
  !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
  !֥롼Ѥ뤿Ǥ. 
  !
  use gridset,  only: DimZMin,       &! Z β
    &                 RegZMin,       &! Z β
    &                 DimZMax,       &! Z ξ
    &                 s_Z,           &!顼ʻǤι
    &                 DelZ            !Z γʻֳ
  use basicset, only: &
    &                 MolWtDry,      &!ʬʬ
    &                 Grav,          &!ϲ®
    &                 Tropopause,    &!ή̹
    &                 GasRUniv        !

  implicit none

  integer :: k
  real(8), intent(in)    :: Humidity      !ܾм
  real(8), intent(in)    :: TempStrat     !طβ [k]
  real(8), intent(in)    :: Dhight        !ŤߴؿΥѥ᡼ [m]
  real(8), intent(inout) :: z_TempBasicZ(DimZMin:DimZMax)
  real(8), intent(inout) :: z_PressBasicZ(DimZMin:DimZMax)
  real(8) :: z_DTempDZ(DimZMin:DimZMax)
  real(8) :: DTempDZ
  real(8) :: Weight


  do k = RegZMin+1, DimZMax-1     
     z_DTempDZ(k) = (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / DelZ
  end do
  
  ! ή̤ΰ
  !   ̤絤Ȥ. 絤絤ؤܤ 
  !   tanh ѤƤʤ餫ˤĤʤ
  do k = RegZMin+1, DimZMax
    
    !ŤߤĤδؿѰ. tanh Ѥ
    Weight = ( tanh( (s_Z(k) - tropopause ) / Dhight ) + 1.0d0 ) * 5.0d-1
    
    !ͤȤƲ٤׻. ̤Ǥ TempStrat 絤˶Ť
    z_TempBasicZ(k) = z_TempBasicZ(k) * ( 1.0d0 - Weight ) + TempStrat * Weight
    
    !ٸΨǮٸΨ꾮ʤʤ褦
    DTempDZ = &
      & max( z_DTempDZ(k), (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / DelZ )

    !ܾβ٤
    z_TempBasicZ(k) = z_TempBasicZ(k-1) + DTempDZ * DelZ 
    
    !Ϥſ尵ʿդ׻
    z_PressBasicZ(k) =                                                    &
      &  z_PressBasicZ(k-1) * ( ( z_TempBasicZ(k-1) / z_TempBasicZ(k) )   &
      &    ** (Grav * MolWtDry / ( DTempDZ * GasRUniv ) ) )
  end do

end subroutine BasicEnvInit_upper

